using System;
using System.Runtime.InteropServices;

namespace Noesis
{
    public class Log
    {
        /// Logs an info message in NoesisConsole
        public static void Info(string text)
        {
            Noesis_LogInfo(text);
        }

        /// Logs a warning message in NoesisConsole
        public static void Warning(string text)
        {
            Noesis_LogWarning(text);
        }

        #if UNITY_IPHONE || UNITY_XBOX360
        [DllImport("__Internal", EntryPoint="Noesis_LogInfo")]
        #else
        [DllImport("Noesis", EntryPoint = "Noesis_LogInfo")]
        #endif
        static extern void Noesis_LogInfo([MarshalAs(UnmanagedType.LPWStr)]string message);

        #if UNITY_IPHONE || UNITY_XBOX360
        [DllImport("__Internal", EntryPoint="Noesis_LogWarning")]
        #else
        [DllImport("Noesis", EntryPoint = "Noesis_LogWarning")]
        #endif
        static extern void Noesis_LogWarning([MarshalAs(UnmanagedType.LPWStr)]string message);
    }
}
