using System;
using System.Runtime.InteropServices;

namespace Noesis
{

    public partial class UIPropertyMetadata
    {
        public UIPropertyMetadata(object defaultValue)
            : this(Create(defaultValue, null), true)
        {
        }

        public UIPropertyMetadata(object defaultValue, PropertyChangedCallback propertyChangedCallback)
            : this(Create(defaultValue, propertyChangedCallback), true)
        {
        }

        private static IntPtr Create(object defaultValue, PropertyChangedCallback propertyChangedCallback)
        {
            return Create(defaultValue, propertyChangedCallback,
                (def, invoke) => Noesis_CreateUIPropertyMetadata_(def, invoke));
        }

        #region Imports
        private static IntPtr Noesis_CreateUIPropertyMetadata_(HandleRef defaultValue,
            DelegateInvokePropertyChangedCallback invokePropertyChangedCallback)
        {
            IntPtr result = Noesis_CreateUIPropertyMetadata(defaultValue,
                invokePropertyChangedCallback);
            Error.Check();
            return result;
        }

        ////////////////////////////////////////////////////////////////////////////////////////////////
        #if UNITY_IPHONE || UNITY_XBOX360
        [DllImport("__Internal", EntryPoint="Noesis_CreateUIPropertyMetadata")]
        #else
        [DllImport("Noesis", EntryPoint = "Noesis_CreateUIPropertyMetadata")]
        #endif
        private static extern IntPtr Noesis_CreateUIPropertyMetadata(HandleRef defaultValue,
            DelegateInvokePropertyChangedCallback invokePropertyChangedCallback);

        #endregion
    }

}
